package me.Demon.DemonGemsSocket.listener;

import me.Demon.DemonGemsSocket.GemsAPI;
import me.Demon.DemonGemsSocket.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class GemsGuiEvent implements Listener {

    @EventHandler
    public void onGemsGuiClick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        if (e.getInventory() != null && inv.getTitle().equalsIgnoreCase("§9§l宝石镶嵌系统")) {
            e.setCancelled(true);
            if (e.getRawSlot() >= inv.getSize()) {
                ItemStack item = e.getCurrentItem();
                if (!Main.itemIsNull(item) && !Main.itemIsLore(item)) {
                    ItemMeta meta = item.getItemMeta();
                    if (meta.getLore().contains(Main.EmptyLore)) {
                        inv.setItem(10, item);
                        e.setCurrentItem(new ItemStack(Material.AIR));
                        p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                    } else {
                        p.sendMessage(Main.prefix + "镶嵌失败，该物品没有可以空余宝石槽。");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                    }
                }
            }
            if (e.getRawSlot() == 10) {
                if (!Main.itemIsLore(e.getCurrentItem())) {
                    p.getInventory().addItem(e.getCurrentItem());
                    inv.setItem(10, GemsGui.glass(0, "§7[§6请放入装备§7]"));
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
                }
            }
            if (e.getRawSlot() == 16) {
                ItemStack item = inv.getItem(10).clone();
                if (Main.itemIsLore(item) || !item.getItemMeta().getLore().contains(Main.EmptyLore)) {
                    p.sendMessage(Main.prefix + "镶嵌失败，该物品没有可以空余宝石槽。");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                    return;
                }
                ItemStack gems = inv.getItem(11).clone();
                if (GemsAPI.getGems_Key(gems) == null) {
                    p.sendMessage(Main.prefix + "宝石配置出现错误，请联系管理员。");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                    return;
                }
                String Gems_Key = GemsAPI.getGems_Key(gems);
                if (GemsAPI.gettype(Gems_Key).equalsIgnoreCase("Armor")) {
                    if (!isArmor(item)) {
                        p.sendMessage(Main.prefix + "镶嵌失败，这是一颗防具宝石。");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                } else if (GemsAPI.gettype(Gems_Key).equalsIgnoreCase("Weapon")) {
                    if (isArmor(item)) {
                        p.sendMessage(Main.prefix + "镶嵌失败，这是一颗武器宝石。");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                }
                int chance = GemsAPI.getchance(Gems_Key);
                String replore = "§1§6§r§8- §8< " + GemsAPI.getname(Gems_Key) + " §8>§1§6§r";
                if (gems.getItemMeta().getLore().contains("§e▶ §7神护: §a§l✔")) {
                    GemsXiruEvant(inv, p, item, replore);
                    return;
                }
                if (Main.getRandomInt(100, 1) < chance) {
                    GemsXiruEvant(inv, p, item, replore);
                } else {
                    inv.setItem(11, GemsGui.glass(15, "板子"));
                    p.sendMessage(Main.prefix + "镶嵌失败，不要灰心继续努力！下一个会成功镶嵌的！");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                    p.closeInventory();
                }
            }
            if (e.getRawSlot() == 14) {
                p.closeInventory();
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
            }
        }
    }

    public static void GemsXiruEvant(Inventory inv, Player p, ItemStack item, String replore) {
        inv.setItem(10, GemsGui.glass(15, "板子"));
        inv.setItem(11, GemsGui.glass(15, "板子"));
        p.closeInventory();
        p.getInventory().addItem(AddGemsItemsEvant(item, replore));
        p.sendMessage(Main.prefix + "镶嵌成功，装备已自动回到背包中。");
        p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
    }

    public static ItemStack AddGemsItemsEvant(ItemStack item, String replore) {
        ItemStack items = item.clone();
        ItemMeta meta = items.getItemMeta();
        List<String> lore = meta.getLore();
        for (int i = 0; i < lore.size(); i++) {
            String s = lore.get(i);
            if (s.contains(Main.EmptyLore)) {
                lore.set(i, replore);
                break;
            }
        }
        meta.setLore(lore);
        items.setItemMeta(meta);
        return items;
    }

    //判断物品是否是防具
    public static boolean isArmor(ItemStack item) {
        Material material = item.getType();
        if (material.name().contains("_HELMET")) {
            return true;
        } else if (material.name().contains("_CHESTPLATE")) {
            return true;
        } else if (material.name().contains("_LEGGINGS")) {
            return true;
        } else if (material.name().contains("_BOOTS")) {
            return true;
        }
        return false;
    }
}
